module CropimageRiffpad::CropImageHelper
  def crop_image_helper(model_name, attachment_name, style)
    @object = ActiveSupport::Inflector.constantize(ActiveSupport::Inflector.classify(model_name)).find(params[:id])
    html = [javascript_tag(%Q{
        $(function() {
      	  $('#cropbox').Jcrop({
      	    onChange: update_crop,
      	    onSelect: update_crop,
      	    setSelect: [10, 10, 100, 100],
      	    aspectRatio: 1
      	  });
      	});

      	function update_crop(coords) {
    			var rx = 100/coords.w;
    			var ry = 100/coords.h;
    			$('#preview').css({
    				width: Math.round(rx * #{@object.send("#{attachment_name}_geometry", style).width}) + 'px',
    				height: Math.round(ry * #{@object.send("#{attachment_name}_geometry", style).height}) + 'px',
    				marginLeft: '-' + Math.round(rx * coords.x) + 'px',
    				marginTop: '-' + Math.round(ry * coords.y) + 'px'
    			});
    		  var ratio = #{@object.send("#{attachment_name}_geometry", :original).width} / #{@object.send("#{attachment_name}_geometry", style).width};
    		  $("#crop_x").val(Math.round(coords.x * ratio));
    		  $("#crop_y").val(Math.round(coords.y * ratio));
    		  $("#crop_w").val(Math.round(coords.w * ratio));
    		  $("#crop_h").val(Math.round(coords.h * ratio));
    		}
    	}
  	)]
    html << content_tag(:div, id: "content") do
      content_tag(:div, class: "form_show") do
        [content_tag(:div, class: "fs-header") do
          content_tag(:p, "Edit Your Profile Photo", class: "fs-title") 
        end,
        content_tag(:div, class: "fs-content") do 
          [content_tag(:p, "Position or align your photo by resizing the square below.", class: "fs-c-h1"),
          content_tag(:p, "You can see how these changes will appear in your profile in the image on the right.", class: "fs-c-h2")].join.html_safe 
        end,  
        content_tag(:div, class: "image_2") do
          image_tag(@object.send("#{attachment_name}").url(style), id: "preview",)
        end,
        content_tag(:div, class: "clr") do end,
        content_tag(:div, class: "border-1") do end,
        content_tag(:div, class: "image_1") do
          image_tag(@object.send("#{attachment_name}").url(style), id: "cropbox")
        end,   
        content_tag(:div, class: "border-1") do end,    
        (form_for @object do |f|
          fields_array = []
          fields_array << hidden_field_tag("crop", true)
          for attribute in [:crop_x, :crop_y, :crop_w, :crop_h]
            fields_array << f.hidden_field(attribute, :id => attribute)
          end
          fields_array << f.submit("Save", class: "button_submit")
          fields_array.join.html_safe
        end)].join.html_safe
      end
    end
    
    html.join.html_safe
  end
end
